WITH   Ada.Unchecked_Conversion ;
WITH   Interfaces.C ;
WITH   Stdarg ;
WITH   System ;
WITH   Win32 ;
WITH   Win32.Crt.Strings ;
WITH   Win32.Windef ;
WITH   Win32.Wingdi ;
WITH   Win32.Winuser ;

PACKAGE BODY   CharTb24_Pkg  IS

   FUNCTION   CP   ( I_Str : Win32.CHAR_Array )  RETURN  Win32.LPCSTR  IS
      FUNCTION   UC  IS
         new Ada.Unchecked_Conversion ( System.Address , Win32.LPCSTR );
   BEGIN
      RETURN  UC ( I_Str(I_Str'First)'Address );
   END CP;

   FUNCTION   CPS   ( I_Str : Win32.CHAR_Array )  RETURN  Win32.LPSTR  IS
      FUNCTION   UC  IS
         new Ada.Unchecked_Conversion ( System.Address , Win32.LPSTR );
   BEGIN
      RETURN  UC ( I_Str(I_Str'First)'Address );
   END CPS;

   FUNCTION   To_IntW  IS  new Ada.Unchecked_Conversion(Win32.PCHAR, Integer);
   FUNCTION   To_PCHAR  IS  new Ada.Unchecked_Conversion(Integer, Win32.PCHAR);

   USE TYPE   Win32.CHAR_Array ;      --- To get "&"

   Nul : Win32.Char RENAMES Win32.Nul ;

   wm_MyAction : CONSTANT := Win32.Winuser.WM_USER + 101 ;

   C_MainMsg : CONSTANT Win32.CHAR_Array := "CharTb24..., "  &  Nul ;

   C_MainPMTitle : CONSTANT Win32.CHAR_Array := "Information"  &  Nul ;

   CRLF : CONSTANT Win32.CHAR_Array := Win32.Char(Character'Val(13))  &  Win32.Char(Character'Val(10));

   C_TitleLn1 : CONSTANT Win32.CHAR_Array := "CODE   CHAR"  &  CRLF  &  Nul ;
   C_TitleLn2 : CONSTANT Win32.CHAR_Array := "-----------"  &  CRLF  &  Nul ;
   C_NumberFmt : CONSTANT Win32.CHAR_Array := "%u"  &  Nul ;
   C_3SpacesZ : CONSTANT Win32.CHAR_Array := "   "  &  Nul ;
   CRLFz : CONSTANT Win32.CHAR_Array := Win32.Char(Character'Val(13))  &  Win32.Char(Character'Val(10))  &  Nul ;

   L_PaintStruct : ALIASED Win32.Winuser.PAINTSTRUCT ;
   L_Rect        : ALIASED Win32.Windef.RECT := (0,0,0,0);

   L_Buffer : ALIASED Win32.CHAR_Array(0..4096);
   L_Buf25  : ALIASED Win32.CHAR_Array(0..25);
   L_Buf01z : ALIASED Win32.CHAR_Array(0..1);

   FUNCTION   MainWindow_Proc   ( I_HWnd    : Win32.Windef.HWND
                                ; I_Message : Win32.UINT
                                ; I_WParam  : Win32.WPARAM
                                ; I_LParam  : Win32.LPARAM )  RETURN  Win32.LRESULT  IS
      FUNCTION   "&"  IS  new Stdarg.Concat ( Win32.LONG );

      L_HDC : Win32.Windef.HDC ;
      L_PREV_GdiObj : Win32.Windef.HGDIOBJ ;
      IgnoredH      : Win32.Windef.HGDIOBJ ;

      L_P : Win32.LPSTR ;
      L_TmpLen : Standard.INTEGER ;
   BEGIN
      CASE I_Message IS
         WHEN wm_MyAction =>
            L_Buffer(0) := Nul ;
            L_P := CPS(L_Buffer);

            IgnoredP := Win32.Crt.Strings.StrCpy ( L_P , CP(C_TitleLn1) );
            IgnoredP := Win32.Crt.Strings.StrCat ( L_P , CP(C_TitleLn2) );
            L_TmpLen := Standard.INTEGER( Win32.Crt.Strings.StrLen(Win32.PCCH(L_P)) );
            L_P      := To_PCHAR(To_IntW(L_P) + L_TmpLen);

            L_Buf01z(1) := Nul ;

            ----- LOOP , On each char
            FOR i in 0..255 LOOP
               IgnoredI := Win32.Winuser.wvsprintf ( CPS(L_Buf25) , CP(C_NumberFmt)
                                                   , Stdarg.Empty & Win32.LONG(i) );
               IgnoredP := Win32.Crt.Strings.StrCpy ( L_P , CP(L_Buf25) );
               IgnoredP := Win32.Crt.Strings.StrCat ( L_P , CP(C_3SpacesZ) );

               ----- Write char  ( Ignoring problem chars )
               CASE i IS
                  WHEN 0  => L_Buf01z(0) := '-' ;      --- EOF   End Of File
                  WHEN 9  => L_Buf01z(0) := '-' ;      --- HT    Tabulation
                  WHEN 10 => L_Buf01z(0) := '-' ;      --- LF    Line Feed
                  WHEN 13 => L_Buf01z(0) := '-' ;      --- CR    Carriage Return

                  WHEN OTHERS =>
                     L_Buf01z(0) := Win32.Char(Character'Val(i));
               END CASE;
               IgnoredP := Win32.Crt.Strings.StrCat ( L_P , CP(L_Buf01z) );

               IgnoredP := Win32.Crt.Strings.StrCat ( L_P , CP(CRLFz) );

               L_TmpLen := Standard.INTEGER( Win32.Crt.Strings.StrLen(Win32.PCCH(L_P)) );
               L_P      := To_PCHAR(To_IntW(L_P) + L_TmpLen);
            END LOOP;--i

            IgnoredI := Win32.Winuser.MessageBox ( System.Null_Address
                                                 , CP(L_Buffer)
                                                 , CP(C_MainPMTitle)
                                                 , Win32.Winuser.MB_OK or Win32.Winuser.MB_ICONEXCLAMATION );

         WHEN Win32.Winuser.WM_PAINT =>
            L_HDC := Win32.Winuser.BeginPaint ( I_HWnd , L_PaintStruct'Access );
            IgnoredB := Win32.Winuser.GetClientRect ( I_HWnd , L_Rect'Access );

            L_PREV_GdiObj := Win32.Wingdi.SelectObject ( L_HDC
                                                       , Win32.Wingdi.GetStockObject(Win32.Wingdi.SYSTEM_FIXED_FONT) );

            IgnoredI := Win32.Winuser.DrawText ( L_HDC
                                               , CP(C_MainMsg)
                                               , Interfaces.C.Int( Win32.Crt.Strings.StrLen(CP(C_MainMsg)) )
                                               , L_Rect'Access
                                               , Win32.Winuser.DT_WORDBREAK );

            IgnoredH := Win32.Wingdi.SelectObject ( L_HDC , L_PREV_GdiObj );
            IgnoredB := Win32.Winuser.EndPaint ( L_HDC , L_PaintStruct'Access );

            ----- Only once...
            IF not G_MainPaintedOnceQ THEN
               G_MainPaintedOnceQ := Standard.TRUE ;
               IgnoredB := Win32.Winuser.PostMessage ( I_HWnd , wm_MyAction , 0 , 0 );      --- "Indirect" call...
            END IF;

         WHEN Win32.Winuser.WM_SIZE =>      --- When window is resized,...
            ----- Force paint again
            IgnoredB := Win32.Winuser.GetClientRect ( I_HWnd , L_Rect'Access );
            IgnoredB := Win32.Winuser.InvalidateRect ( I_HWnd , L_Rect'Access , Win32.FALSE );

         WHEN Win32.Winuser.WM_DESTROY =>
            Win32.Winuser.PostQuitMessage(0);

         WHEN OTHERS =>
            RETURN  Win32.Winuser.DefWIndowProc ( I_HWnd , I_Message , I_WParam , I_LParam );
      END CASE;

      ----- Default result : Msg processed!!!
      RETURN  0 ;
   END MainWindow_Proc;
END CharTb24_Pkg;
